<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class SystemparameterValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		if(empty($input["variableName"])){
			array_push($this->error, ["variableName" => "cannot be null"]);
		}
		else{
			$lengthvariablename = strlen($input["variableName"]);
			if($lengthvariablename>200){
			array_push($this->error, ["variablename" => "value too long"]);
			}
		}
		if(!empty($input["variablename"])){
			$variablename= (new \App\Http\Models\SystemparameterModel())->getQuery()
			->where("systemparameter.variableName","=",$input["variableName"])->first();
			if(($variablename)){
			array_push($this->error, ["variablename" => "Value Already Exist"]);
			}
		}
		if(empty($input["variableValue"])){
			array_push($this->error, ["variableValue" => "cannot be null"]);
		}
		else{
			$lengthvariablevalue = strlen($input["variableValue"]);
			if($lengthvariablevalue>2000){
			array_push($this->error, ["variablevalue" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["variableName"])){
			array_push($this->error, ["variableName" => "cannot be null"]);
		}
		else{
			$lengthvariablename = strlen($input["variableName"]);
			if($lengthvariablename>200){
			array_push($this->error, ["variablename" => "value too long"]);
			}
		}
		if(!empty($input["variablename"])){
			$variablename= (new \App\Http\Models\SystemparameterModel())->getQuery()
			->where("systemparameter.variableName","=",$input["variableName"])->first();
			if(($variablename)&& ($id !=$variablename->id)){
			array_push($this->error, ["variablename" => "Value Already Exist"]);
			}
		}
		if(empty($input["variableValue"])){
			array_push($this->error, ["variableValue" => "cannot be null"]);
		}
		else{
			$lengthvariablevalue = strlen($input["variableValue"]);
			if($lengthvariablevalue>2000){
			array_push($this->error, ["variablevalue" => "value too long"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

    }


}